import 'package:supabase/src/supabase_realtime_client.dart';
import 'package:supabase/supabase.dart';
import 'package:test/test.dart';

void main() {
  const supabaseUrl = 'https://wwswosyfqfwqjkmsprci.supabase.net';
  const supabaseKey =
      'eyJhbGciOiJIUzI1NiIsInR5cCI6IkpXVCJ9.eyJyb2xlIjoiYW5vbiIsImlhdCI6MTYxMjQyMzU1NCwiZXhwIjoxOTI3OTk5NTU0fQ.AkkfN4q7KewkQk7vSZ-kI5BSQvea_2_HVPgtIY0vyPI';
  SupabaseClient client;

  setUp(() {
    client = SupabaseClient(supabaseUrl, supabaseKey);
  });

  test('postgrest builder url', () async {
    final builder = client.from('users').select();
    expect(builder.url.toString(), '/rest/v1/users?select=%2A');
  });

  test('realtime', () async {
    final supscription1 =
        client.from('countries').on(SupabaseEventTypes.delete, (res) {
      print('on countries.delete: ${res.table} ${res.eventType} ${res.olds}');
    }).subscribe((String event, {String errorMsg}) {
      print('event: $event error: $errorMsg');
    });

    final supscription2 =
        client.from('todos').on(SupabaseEventTypes.insert, (res) {
      print('on todos.insert: ${res.table} ${res.eventType} ${res.news}');
    }).subscribe((String event, {String errorMsg}) {
      print('event: $event error: $errorMsg');
    });

    await Future.delayed(const Duration(seconds: 50), () {});
    client.removeSubscription(supscription1);
    client.removeSubscription(supscription2);
  }, timeout: const Timeout(Duration(seconds: 500)));
}
